#!/usr/bin/perl
#
use DBI;
use DBD::mysql;
use Digest::MD5 qw(md5 md5_hex md5_base64);

# DB stuff ------------------------------------------------------------------

my $db          = "deli";
my $host        = "localhost";
my $port        = "3306";
my $dsn         = "DBI:mysql:database=$db;host=$host;port=$port";
my $user        = "icious";
my $pass        = "asdasdasd";

my $dbh         = DBI->connect($dsn, $user, $pass);

die "Could not connect to the DB\n\n" unless $dbh;

# ---------------------------------------------------------------------------

my $url = $ARGV[0];
my $md5 = md5_hex($url);
print "$url\n$md5\n";

my %h;          # handler for queries
prepare_q (\%h, $dbh);

$h{q1}->execute($md5) || die ("Error in execute");
my $numusr = ($h{q1}->fetchrow_array())[0];
print "Users: $numusr\t";

$h{q2}->execute($md5) || die ("Error in execute");
my $numtag = ($h{q2}->fetchrow_array())[0];
print "Tags: $numtag\t";

$h{q3}->execute($md5) || die ("Error in execute");
my $total = ($h{q3}->fetchrow_array())[0];
print "Total: $total\n";

print "Tag/user ratio: ".sprintf("%.02f",$total/$numusr)."\n";

$h{q4}->execute($md5) || die ("Error in execute");

my ($tagname, $count);
do {
	($tagname, $count) = $h{q4}->fetchrow_array();
	if ($tagname){
		my $tagusage = $count/$total*100;
		my $percent = $count/$numusr*100;
		print "$url is $tagname for ".sprintf("%.02f\%", $percent)." of the users ($count/$numusr).";
		print " Tag usage: ".sprintf("%.02f\%",$tagusage)." ($count/$total)\n";
	}
	$totalcount += $count;
}while ($tagname);


# ---------------------------------------------------------------------------
sub prepare_q{
        my ($h, $dbh) = @_;

        $$h{q1} = $dbh->prepare("select count(distinct uid) from res,tagged where res.md5=? and res.id=tagged.rid") || die "Error in prepare";
	$$h{q2} = $dbh->prepare("select count(distinct tid) from res,tagged where res.md5=? and res.id=tagged.rid") || die "Error in prepare";
	$$h{q3} = $dbh->prepare("select count(uid) from res,tagged where res.md5=? and res.id=tagged.rid") || die "Error in prepare";
	$$h{q4} = $dbh->prepare("select tag.name, count(*) as count from tag,res,tagged where tag.id=tagged.tid and res.md5=? and res.id=tagged.rid group by tag.name order by count desc") || die "Error in prepare";
}

# ---------------------------------------------------------------------------

