#!/usr/bin/perl
#
use DBI;
use DBD::mysql;
use Digest::MD5 qw(md5 md5_hex md5_base64);
use URI::Escape;

# DB stuff ------------------------------------------------------------------

my $db          = "deli";
my $host        = "localhost";
my $port        = "3306";
my $dsn         = "DBI:mysql:database=$db;host=$host;port=$port";
my $user        = "icious";
my $pass        = "asdasdasd";

my $dbh         = DBI->connect($dsn, $user, $pass);

die "Could not connect to the DB\n\n" unless $dbh;

# ---------------------------------------------------------------------------
my $HAVING_COUNT = 10;

my $tag = $ARGV[0];

my %h;          # handler for queries
prepare_q (\%h, $dbh);

print "Searching for resources tagged as '$tag'...\n";

# get all the urls tagged as 'tag'

$h{q0}->execute($tag, $HAVING_COUNT) || die ("Error in execute");
my $rows = $h{q0}->rows();

my %stats;
my $counter = 1;
my ($url, $id, $count);
do{
	($url, $id, $count) = $h{q0}->fetchrow_array();
	if ($url){
		my $md5 = md5_hex($url);
		$h{q1}->execute($id) || die ("Error in execute");
		my $numusr = ($h{q1}->fetchrow_array())[0];
		my $percent = $count/$numusr*100;

		print "[$counter/$rows] $url is $tag for ".sprintf("%.02f\%", $percent)." of the users ($count/$numusr).\n";
		$counter++;
		$stats{$url} = $percent;
	}
}while ($url);

print "\n";
# sort hash by values
my %vals;
foreach my $key (keys %stats){
	$vals{sprintf("%.02f",$stats{$key})} .= uri_unescape($key)." ";
}

foreach my $key (sort {$b<=>$a} keys %vals){
	print "$key -> $vals{$key}\n";
}


exit;

# ---------------------------------------------------------------------------
sub prepare_q{
        my ($h, $dbh) = @_;

	$$h{q0} = $dbh->prepare("select res.url, res.id, count(*) as count from res,tag,tagged where res.id=tagged.rid and tag.id=tagged.tid and tag.name=? group by res.url having count>=? order by count desc") || die "Error in prepare";
        $$h{q1} = $dbh->prepare("select count(distinct uid) from tagged where rid=?") || die "Error in prepare";
}

# ---------------------------------------------------------------------------

