#!/usr/bin/perl
#
use DBI;
use DBD::mysql;

# DB stuff ------------------------------------------------------------------

my $db          = "deli";
my $host        = "localhost";
my $port        = "3306";
my $dsn         = "DBI:mysql:database=$db;host=$host;port=$port";
my $user        = "icious";
my $pass        = "asdasdasd";

my $dbh         = DBI->connect($dsn, $user, $pass, {
                        RaiseError=>0,
                        PrintError=>0,
                        AutoCommit=>1,
                        HandleError=>\&dbierrorlog}
                );
die "Could not connect to the DB\n\n" unless $dbh;

# ---------------------------------------------------------------------------

my %h;          # handler for queries
prepare_q (\%h, $dbh);

$h{q1}->execute || die ("Error in execute");
my $numusr = ($h{q1}->fetchrow_array())[0];

$h{q2}->execute || die ("Error in execute");
my $numtag = ($h{q2}->fetchrow_array())[0];

$h{q3}->execute || die ("Error in execute");
my $numres = ($h{q3}->fetchrow_array())[0];

$h{q4}->execute || die ("Error in execute");
my $numque = ($h{q4}->fetchrow_array())[0];

$h{q5}->execute || die ("Error in execute");
my $numtagged = ($h{q5}->fetchrow_array())[0];

$h{q6}->execute || die ("Error in execute");
my ($qid, $qnam) = $h{q6}->fetchrow_array();

print "\n=================================================\n";
print " Statistics for deli DB:\n\n";
print " - Users:.......$numusr\n";
print " - Tags:........$numtag\n";
print " - Resources:...$numres\n";
print " - Users in q:..$numque\n";
print " - Taggings:....$numtagged\n";
print " - Currently working on user $qnam (id: $qid)\n";
print "=================================================\n\n";

# ---------------------------------------------------------------------------
sub prepare_q{
        my ($h, $dbh) = @_;

        $$h{q1}  = $dbh->prepare("select count(*) from user") || die "Error in prepare";
        $$h{q2}  = $dbh->prepare("select count(*) from tag") || die "Error in prepare";
        $$h{q3}  = $dbh->prepare("select count(*) from res") || die "Error in prepare";
        $$h{q4}  = $dbh->prepare("select count(*) from userq") || die "Error in prepare";
        $$h{q5}  = $dbh->prepare("select count(*) from tagged") || die "Error in prepare";
        $$h{q6}  = $dbh->prepare("select id,name from userq where locked") || die "Error in prepare";
}

# ---------------------------------------------------------------------------

